%define withmysql 1

Summary: The PHP scripting language.
Name: php
Version: 4.0.6
Release: 1.0.18
Group: Development/Languages
URL: http://www.php.net/
Source0: http://www.php.net/distributions/php-%{version}.tar.gz
Patch1: php-4.0.3-required.patch
Patch2: php-4.0.4pl1-linkage.patch
Patch3: php-4.0.5-db.patch
Patch4: php-4.0.5-ext.patch
Patch5: php-4.0.6-ZVAL.patch
Patch6: php-4.0.6-libtool.patch
Patch7: php-4.0.6-redhat.patch
Patch10: php-4.0.6-rfc1867-gd-1.diff
Patch11: php-4.0.6-no-uploads-gd-1.diff
Copyright: PHP
BuildRoot: %{_tmppath}/%{name}-root
BuildPrereq: apache-devel
ExcludeArch: ia64

%define sysconfdir /etc
# %define contentdir /home/httpd/html

%description
PHP is an HTML-embeddable scripting language.  PHP offers built-in database
integration for several commercial and non-commercial database management
systems, so writing a database-enabled script with PHP is fairly simple.  The
most common use of PHP coding is probably as a replacement for CGI scripts.

%package -n mod_php
Summary: The PHP HTML-embedded scripting language for use with Apache.
Group: System Environment/Daemons
URL: http://www.php.net/
Prereq: webserver
Obsoletes: php3, phpfi
BuildPrereq: apache-devel
Prereq: php = %{version}-%{release}

%description -n mod_php
PHP is an HTML-embedded scripting language.  PHP attempts to make it
easy for developers to write dynamically generated web pages.  PHP
also offers built-in database integration for several commercial and
non-commercial database management systems, so writing a
database-enabled web page with PHP is fairly simple.  The most common
use of PHP coding is probably as a replacement for CGI scripts.  The
mod_php module enables the Apache web server to understand and process
the embedded PHP language in web pages.

This package contains PHP version 4.0.  You'll also need to install the
Apache web server.

%if %{withmysql}
%package mysql
Group: Development/Languages
Prereq: php = %{version}-%{release}, perl
Summary: A module for PHP applications that use MySQL databases.
Provides: php_database
Obsoletes: mod_php3-mysql
BuildPrereq: MySQL-devel
Requires: MySQL

%description mysql
The php-mysql package contains a dynamic shared object that will add
MySQL database support to PHP.  MySQL is an object-relational database
management system.  PHP is an HTML-embeddable scripting language.  If
you need MySQL support for PHP applications, you will need to install
this package and the php or mod_php package.
%endif


%prep
%setup -q
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch10 -p1
%patch11 -p1

cp Zend/LICENSE Zend/ZEND_LICENSE

autoconf

%build

CFLAGS="$RPM_OPT_FLAGS -fPIC"; export CFLAGS
export LIBS

### Breaks the 4.0.4+ build.
### --target=%{_target_platform} \
###	--disable-versioning \

compile() {
./configure \
	--prefix=%{_prefix} \
	--sysconfdir=/etc \
	--with-config-file-path=/etc \
	--disable-debug \
	--enable-pic \
	--enable-inline-optimization \
	--with-exec-dir=%{_bindir} \
	--with-regex=system \
	--with-gettext \
	--with-gdbm \
	--enable-magic-quotes \
	--enable-safe-mode \
	--enable-sysvsem \
	--enable-sysvshm \
	--enable-track-vars \
	--enable-ftp \
	--with-xml \
	--with-zlib \
	--disable-pear \
	--disable-yp \
	--without-openssl \
	--enable-versioning \
	--with-mysql=/usr \
	$*
make
}

# Build a standalone binary.
compile --enable-force-cgi-redirect --enable-static
cp php php_standalone
make distclean

# Build a module.
compile --with-apxs=%{_sbindir}/apxs

# Build PHP modules.
build_ext() {
%{__cc} -fPIC -shared $RPM_OPT_FLAGS \
	-DCOMPILE_DL_`echo $1 | tr '[a-z]' '[A-Z]'` \
	-DHAVE_`echo $1 | tr '[a-z]' '[A-Z]'` \
	-I. -I./main -I`%{_sbindir}/apxs -q INCLUDEDIR` -I./Zend \
	-I/usr/include/freetype -I/usr/include/$1 \
	-I./ext/$1 -I./ext/$1/lib$1 \
	-I./ext/xml/expat/xmltok -I./ext/xml/expat/xmlparse \
	-I./TSRM \
	`grep ^CPPFLAGS Zend/Makefile | cut -f2- -d=` \
	$4 $2 -o $1.so -L.libs $3 -lc
}
%if %{withmysql}
build_ext mysql ext/mysql/php_mysql.c "-L/usr/lib/mysql -lmysqlclient" "-DHAVE_MYSQL_MYSQL_H -DHAVE_MYSQL_REAL_CONNECT"
%endif

%install
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{_libdir}/{apache,php4}
mkdir -p $RPM_BUILD_ROOT/etc/httpd
# mkdir -p $RPM_BUILD_ROOT%{contentdir}/icons
mkdir -p $RPM_BUILD_ROOT%{_bindir}
mkdir -p $RPM_BUILD_ROOT/etc/httpd/modules

install -m 755 php_standalone $RPM_BUILD_ROOT%{_bindir}/php
install -m 755 .libs/libphp4.so $RPM_BUILD_ROOT%{_libdir}/apache/
install -m 755 .libs/libphp4.so $RPM_BUILD_ROOT/etc/httpd/modules/

strip -g $RPM_BUILD_ROOT%{_libdir}/apache/*
strip -g $RPM_BUILD_ROOT/etc/httpd/modules/*

%if %{withmysql}
install -m 755 mysql.so $RPM_BUILD_ROOT%{_libdir}/php4/
%endif

strip -g $RPM_BUILD_ROOT%{_libdir}/php4/*
install -m 644 php.ini-dist $RPM_BUILD_ROOT/etc/php.ini
# install -m 644 *.gif $RPM_BUILD_ROOT%{contentdir}/icons/

%clean
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT


%post -n mod_php
  perl -pi -e 's|^#LoadModule php4_module        modules/libphp4.so|LoadModule php4_module        modules/libphp4.so|g' /etc/httpd/conf/httpd.conf
  perl -pi -e 's|^#AddModule mod_php4.c|AddModule mod_php4.c|g' /etc/httpd/conf/httpd.conf
  perl -pi -e 's|^#AddType application/x-httpd-php3 .php3|AddType application/x-httpd-php3 .php3|g' /etc/httpd/conf/httpd.conf
  perl -pi -e 's|^#AddType application/x-httpd-php .php4|AddType application/x-httpd-php .php4|g' /etc/httpd/conf/httpd.conf
  perl -pi -e 's|^#AddType application/x-httpd-php .php|AddType application/x-httpd-php .php|g' /etc/httpd/conf/httpd.conf

  # Ugly hack to fix my mistake (see 2000/11/22 changelog entry)
  %{__perl}  -pi -e 's|^LoadModule php4_module        modules/libphp4.so| LoadModule php4_module        modules/libphp4.so|g' /etc/httpd/conf/httpd.conf
  %{__perl}  -pi -e 's|^AddModule mod_php4.c| AddModule mod_php4.c|g' /etc/httpd/conf/httpd.conf
  %{__perl}  -pi -e 's|^AddType application/x-httpd-php3 .php3| AddType application/x-httpd-php3 .php3|g' /etc/httpd/conf/httpd.conf
  %{__perl}  -pi -e 's|^AddType application/x-httpd-php .php4| AddType application/x-httpd-php .php4|g' /etc/httpd/conf/httpd.conf
  %{__perl}  -pi -e 's|^AddType application/x-httpd-php .php| AddType application/x-httpd-php .php|g' /etc/httpd/conf/httpd.conf


%postun -n mod_php
  if [ $1 = 0 ]; then
	perl -pi -e 's|^LoadModule php4_module        modules/libphp4.so|#LoadModule php4_module        modules/libphp4.so|g' /etc/httpd/conf/httpd.conf
	perl -pi -e 's|^AddModule mod_php4.c|#AddModule mod_php4.c|g' /etc/httpd/conf/httpd.conf
	perl -pi -e 's|^AddType application/x-httpd-php3 .php3|#AddType application/x-httpd-php3 .php3|g' /etc/httpd/conf/httpd.conf
	perl -pi -e 's|^AddType application/x-httpd-php .php4|#AddType application/x-httpd-php .php4|g' /etc/httpd/conf/httpd.conf
	perl -pi -e 's|^AddType application/x-httpd-php .php|#AddType application/x-httpd-php .php|g' /etc/httpd/conf/httpd.conf
  fi


%files -n mod_php
%defattr(-,root,root)
# %{contentdir}/icons/*
%{_libdir}/apache/libphp4.so
/etc/httpd/modules/libphp4.so


%files
%defattr(-,root,root)
%doc CODING_STANDARDS CREDITS FUNCTION_LIST.txt INSTALL LICENSE
%doc EXTENSIONS FUNCTION_LIST.txt TODO
%doc NEWS README.* Zend/ZEND_*
%config /etc/php.ini
%{_bindir}/php
#%{_datadir}/php


%if %{withmysql}
%files mysql
%defattr(-,root,root)
%{_libdir}/php4/mysql.so


%post mysql
%{__perl} -pi -e "s|^;extension=mysql.so|extension=mysql.so|" /etc/php.ini


%preun mysql
if [ $1 = 0 ] ; then
  %{__perl} -pi -e "s|^extension=mysql.so|;extension=mysql.so|" /etc/php.ini
fi
%endif


%changelog
* Wed Feb 27 2002 Ryan W. Maple <ryan@guardiandigital.com>
- Version 4.0.4pl1, Revision 1.0.1[678]
  - Upgrade to 4.0.6.
  - Incorporate rfc1867.c (file upload) security patch.
  - Bring in a bunch of Red Hat patches while I'm at it.
  - Really removed all the manual stuff.
  - Disable file uploads in the php.ini.
  - Only run %postun if we are not upgrading.
  - Ugly hack to fix broken %postun that the user will have installed. :(

* Wed Mar 28 2001 Ryan W. Maple <ryan@guardiandigital.com>
- Version 4.0.4pl1, Revision 1.0.15.
  - Rebuild against libmysqlclient.so.10

* Tue Jan 23 2001 Ryan W. Maple <ryan@guardiandigital.com>
- Version 4.0.4pl1, Revision 1.0.14.
  - New version which fixes BTID# 2206.
  - Removed the 'manual' package.

* Fri Dec 29 2000 Ryan W. Maple <ryan@guardiandigital.com>
- Version 4.0.4, Revision 1.0.13.
  - Recompile against apache with pthreads.
  - Upgrade to 4.0.4.
  - Fixes PHP Bug ID #8298

* Thu Dec 07 2000 Ryan W. Maple <ryan@guardiandigital.com>
- Version 4.0.3pl1, Revision 1.0.5.
  - Trying to fix segfault, tweaked zlib in ./configure.

* Wed Nov 22 2000 Ryan W. Maple <ryan@guardiandigital.com>
- Version 4.0.3pl1, Revision 1.0.3.
- Put module in /etc/httpd/modules.
- It now auto-updates the httpd.conf on install and un-install.

* Tue Oct 31 2000 Ryan W. Maple <ryan@guardiandigital.com>
- Took out all the imap/pgsql/ldap stuff.
- Took out all the "unnecessary" compile-time options.
- Happy Halloween!

* Mon Oct 16 2000 Peter Hanecak <hanecak@megaloman.sk>
- update to 4.0.3pl1
- do not make documentation packages for i586 and i686 architectures

* Thu Oct 12 2000 Peter Hanecak <hanecak@megaloman.sk>
- update to 4.0.3
- merged stuff from RedHat's php-4.0.2-2 package (patches, requires, devel
  subpackage, ...)

* Thu Aug 31 2000 Peter Hanecak <hanecak@megaloman.sk>
- update to 4.0.2
- --with-xpm-dir=%{_prefix}/X11R6 added to configure call
- %%{_sysconfdir} used more

* Mon Jul 24 2000 Peter Hanecak <hanecak@megaloman.sk>
- rebuild against 7.0.2

* Tue Jul 18 2000 Peter Hanecak <hanecak@megaloman.sk>
- source archives changed to .bz2
- mysql, pgsql, ldap and imap support conditional at build-time
- MySQL used instead of mysql (I'm using "vanilla" mysql)

* Sat Jul  1 2000 Nalin Dahyabhai <nalin@redhat.com>
- update to 4.0.1pl2
- enable MySQL client
- move the php.ini file to /etc

* Fri Jun 30 2000 Nils Philippsen <nils@redhat.de>
- build_ext defines HAVE_PGSQL so pgsql.so in fact contains symbols
- post/un scripts tweak php.ini correctly now

* Thu Jun 28 2000 Nalin Dahyabhai <nalin@redhat.com>
- update to 4.0.1
- refresh manual

* Tue Jun 26 2000 Nalin Dahyabhai <nalin@redhat.com>
- rebuild against new krb5 package

* Mon Jun 19 2000 Nalin Dahyabhai <nalin@redhat.com>
- rebuild against new db3 package

* Sat Jun 17 2000 Nalin Dahyabhai <nalin@redhat.com>
- Fix syntax error in post and preun scripts.
- Disable IMAP, LDAP, PgSql in the standalone version because it picks up
  the extensions.

* Fri Jun 16 2000 Nalin Dahyabhai <nalin@redhat.com>
- Unexclude the Sparc arch.
- Exclude the ia64 arch until we get a working Postgres build.
- Stop stripping extensions as aggressively.
- Start linking the IMAP module to libpam again.
- Work around extension loading problems.
- Reintroduce file-editing post and preun scripts for the mod_php extensions
  until we come up with a better way to do it.

* Mon Jun  5 2000 Nalin Dahyabhai <nalin@redhat.com>
- ExcludeArch: sparc for now

* Sun Jun  4 2000 Nalin Dahyabhai <nalin@redhat.com>
- add Obsoletes: phpfi, because their content handler names are the same
- add standalone binary, rename module packages to mod_php
- FHS fixes

* Tue May 23 2000 Nalin Dahyabhai <nalin@redhat.com>
- change license from "GPL" to "PHP"
- add URL: tag
- disable mysql support by default (license not specified)

* Mon May 22 2000 Nalin Dahyabhai <nalin@redhat.com>
- update to PHP 4.0.0
- nuke the -mysql subpackage (php comes with a bundled mysql client lib now)

* Tue May 16 2000 Nalin Dahyabhai <nalin@redhat.com>
- link IMAP module against GSS-API and PAM to get dependencies right
- change most of the Requires to Prereqs, because the post edits config files
- move the PHP *Apache* module back to the right directory
- fix broken postun trigger that broke the post
- change most of the postuns to preuns in case php gets removed before subpkgs

* Thu May 11 2000 Trond Eivind Glomsrd <teg@redhat.com>
- rebuilt against new postgres libraries

* Tue May 09 2000 Preston Brown <pbrown@redhat.com>
- php3 .so modules moved to /usr/lib/php3 from /usr/lib/apache (was incorrect)

* Mon Apr 10 2000 Nalin Dahyabhai <nalin@redhat.com>
- make subpackages require php = %{version} (bug #10671)

* Thu Apr 06 2000 Nalin Dahyabhai <nalin@redhat.com>
- update to 3.0.16

* Fri Mar 03 2000 Cristian Gafton <gafton@redhat.com>
- fixed the post script to work when upgrading a package
- add triggere to fix the older packages

* Tue Feb 29 2000 Nalin Dahyabhai <nalin@redhat.com>
- update to 3.0.15
- add build-time dependency for openldap-devel
- enable db,ftp,shm,sem support to fix bug #9648

* Fri Feb 25 2000 Nalin Dahyabhai <nalin@redhat.com>
- add dependency for imap subpackage
- rebuild against Apache 1.3.12

* Thu Feb 24 2000 Preston Brown <pbrown@redhat.com>
- don't include old, outdated manual.  package one from the php distribution.

* Tue Feb 01 2000 Cristian Gafton <gafton@redhat.com>
- rebuild to fix dependency problem

* Fri Jan 14 2000 Preston Brown <pbrown@redhat.com>
- added commented out mysql module, thanks to Jason Duerstock 
  (jason@sdi.cluephone.com). Uncomment to build if you have mysql installed.

* Thu Jan 13 2000 Preston Brown <pbrown@redhat.com>
- rely on imap-devel, don't include imap in src.rpm (#5099).
- xml enabled (#5393)

* Tue Nov 02 1999 Preston Brown <pborwn@redhat.com>
- added post/postun sections to modify httpd.conf (#5259)
- removed old obsolete faq and gif (#5260)
- updated manual.tar.gz package (#5261)

* Thu Oct 07 1999 Matt Wilson <msw@redhat.com>
- rebuilt for sparc glibc brokenness

* Fri Sep 24 1999 Preston Brown <pbrown@redhat.com>
- --with-apxs --> --with-apxs=/usr/sbin/apxs (# 5094)
- ldap support (# 5097)

* Thu Sep 23 1999 Preston Brown <pbrown@redhat.com>
- fix cmdtuples for postgresql, I had it slightly wrong

* Tue Aug 31 1999 Bill Nottingham <notting@redhat.com>
- subpackages must obsolete old stuff...

* Sun Aug 29 1999 Preston Brown <pbrown@redhat.com>
- added -DHAVE_PGCMDTUPLES for postgresql module (bug # 4767)

* Fri Aug 27 1999 Preston Brown <pbrown@redhat.com>
- name change to php to follow real name of package
- fix up references to php3 to refer to php
- upgrade to 3.0.12
- fixed typo in pgsql postun script (bug # 4686)

* Mon Jun 14 1999 Preston Brown <pbrown@redhat.com>
- upgraded to 3.0.9
- fixed postgresql module and made separate package
- separated manual into separate documentation package

* Mon May 24 1999 Preston Brown <pbrown@redhat.com>
- upgraded to 3.0.8, which fixes problems with glibc 2.1.
- took some ideas grom Gomez's RPM.

* Tue May 04 1999 Preston Brown <pbrown@redhat.com>
- hacked in imap support in an ugly way until imap gets an official
  shared library implementation

* Fri Apr 16 1999 Preston Brown <pbrown@redhat.com>
- pick up php3.ini

* Wed Mar 24 1999 Preston Brown <pbrown@redhat.com>
- build against apache 1.3.6

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 2)

* Mon Mar 08 1999 Preston Brown <pbrown@redhat.com>
- upgraded to 3.0.7.

* Wed Feb 24 1999 Preston Brown <pbrown@redhat.com>
- Injected new description and group.

* Sun Feb 07 1999 Preston Brown <pbrown@redhat.com>
- upgrade to php 3.0.6, built against apache 1.3.4

* Mon Oct 12 1998 Cristian Gafton <gafton@redhat.com>
- rebuild for apache 1.3.3

* Thu Oct 08 1998 Preston Brown <pbrown@redhat.com>
- updated to 3.0.5, fixes nasty bugs in 3.0.4.

* Sun Sep 27 1998 Cristian Gafton <gafton@redhat.com>
- updated to 3.0.4 and recompiled for apache 1.3.2

* Thu Sep 03 1998 Preston Brown <pbrown@redhat.com>
- improvements; builds with apache-devel package installed.

* Tue Sep 01 1998 Preston Brown <pbrown@redhat.com>
- Made initial cut for PHP3.
